<script lang="ts" setup>
  import { ProductListingEventEnum } from '~/components/presentation/model';

  const emit = defineEmits<{
    (e: 'trigger', event: ProductListingEventEnum, options?: any): void;
  }>();
  const autoSave = ref<boolean>();

  const currentChanges = ref<{ add: string[]; remove: string[] }>();

  const {
    currentListingKey,
    currentProductListingSlide,
    isCreateMode,
    updateProductListing,
    createProductListing,
    currentPickedProductIds,
    productListingStorage,
  } = useProductListing();

  const publishProductListingsModalController = useModal();
  const discardChangesModalController = useModal();
  const updating = ref(false);
  const publishing = ref(false);

  onBeforeMount(() => {
    if (productListingStorage.value[currentListingKey.value]) {
      currentChanges.value = productListingStorage.value[currentListingKey.value];
    }
  });

  const publish = async (payload: {
    name: string;
    currentPageGroupId: string | null;
    goToNewSlide: boolean;
  }) => {
    if (!currentChanges.value?.add?.length) return;
    publishing.value = true;
    await createProductListing({
      ...payload,
      productIds: currentChanges.value?.add,
    });
    publishing.value = false;
    nextTick(() => {
      emit('trigger', ProductListingEventEnum.GO_BACK);
    });
  };

  const discard = () => {
    // remove all local save
    delete productListingStorage.value?.[currentListingKey.value];
    nextTick(() => {
      emit('trigger', ProductListingEventEnum.GO_BACK);
    });
  };

  const handleChange = (e: any) => {
    currentChanges.value = e.add?.length || e.remove?.length ? e : undefined;
    const temp = productListingStorage.value;
    if (!currentChanges.value) {
      delete temp[currentListingKey.value];
    } else {
      temp[currentListingKey.value] = currentChanges.value;
    }
    productListingStorage.value = temp;
    if (!autoSave.value) return;
    // update when autosave on
    updateDebounced();
  };

  const askForPublish = () => {
    publishProductListingsModalController.open();
  };

  const update = async () => {
    if (!currentChanges.value) return;
    updating.value = true;
    await updateProductListing({
      removeProductIds: currentChanges.value.remove,
      addProductIds: currentChanges.value.add,
    });
    currentChanges.value = undefined;
    updating.value = false;
  };

  const updateDebounced = useDebounceFn(() => {
    update();
  }, 1000);

  const askForDiscardChanges = () => {
    discardChangesModalController.open();
  };

  const handleGoBack = () => {
    if (currentChanges.value) {
      discardChangesModalController.open();
    } else {
      emit('trigger', ProductListingEventEnum.GO_BACK);
    }
  };

  // when change autoSave mode, the list should be saved
  watchDebounced(
    autoSave,
    () => {
      update();
    },
    {
      debounce: 500,
    },
  );
</script>

<template>
  <Teleport to="#left-sidebar">
    <SwSidebar class="absolute left-0 top-0" :loading="publishing" :show-close-btn="false">
      <template #header>
        <div class="flex w-full flex-col gap-5">
          <div class="flex items-center justify-between">
            <SwButton variant="action" class="!p-2" @click="handleGoBack">
              <span class="i-sw-solid:chevron-circle-left text-base"></span>
            </SwButton>

            <p class="line-clamp-1 overflow-hidden text-ellipsis px-2.5 text-lg font-bold">
              {{ isCreateMode ? $t('listing.new') : currentProductListingSlide.groupName }}
            </p>

            <SwButton
              variant="action"
              class="!p-2"
              @click="$emit('trigger', ProductListingEventEnum.CLOSE_PRODUCT_LISTING_LAYER)"
            >
              <span class="i-sw-solid:times-circle text-base" />
            </SwButton>
          </div>
        </div>
      </template>

      <template #body>
        <div class="flex h-full flex-col p-6">
          <div class="border-(b border) mb-8 flex flex-col pb-8">
            <span class="pb-4 font-bold">{{ $t('listing.actions') }}</span>
            <div v-if="!isCreateMode" class="flex space-x-3 pb-6">
              <div class="flex-none">
                <SwToggle v-model="autoSave" />
              </div>
              <div class="grow">
                <div class="flex flex-col">
                  <h5 class="text-sm font-semibold">
                    {{ $t('listing.productListings.autoSave.headline') }}
                  </h5>
                  <span class="text-information-subdued pt-0.5 text-xs">{{
                    $t('listing.productListings.autoSave.sublime')
                  }}</span>
                </div>
              </div>
            </div>

            <SwButton
              v-if="isCreateMode"
              size="large"
              :disabled="!currentChanges"
              @click="askForPublish"
            >
              {{ $t('listing.publish') }}
            </SwButton>

            <SwButton
              v-else
              size="large"
              class="!py-3"
              :loading="updating"
              :disabled="autoSave"
              @click="update"
            >
              {{ $t('listing.update') }}
            </SwButton>

            <SwButton
              variant="action"
              class="mt-3"
              size="large"
              :disabled="autoSave || !currentChanges"
              @click="askForDiscardChanges"
            >
              {{ $t('discardChanges') }}
            </SwButton>
          </div>
          <ProductsFilteringComposition
            :default-value="currentPickedProductIds"
            :cache="currentChanges"
            show-bookmark-shortcut
            multiple-selection
            @change="handleChange"
          />
        </div>
      </template>
      <template #footer>
        <SlideNotes />
      </template>
    </SwSidebar>
  </Teleport>

  <PublishProductListingModal
    v-if="publishProductListingsModalController.isOpen"
    :controller="publishProductListingsModalController"
    @submit="publish"
  />

  <DiscardChangesModal
    v-if="discardChangesModalController.isOpen"
    :controller="discardChangesModalController"
    @submit="discard"
  />
</template>
